import java.util.Scanner;


//I'm a computer science sophemore and this class contains fields and methods on a team full of players from the Player class.
public class Team {
	private String teamName;
	private String country;
	private Player[] players;
	private String formation;
	private int scoringAbility;
	private boolean won;
	
	public Team(Scanner input) {
		//constructor that fills the team information based on a file input by scanning it.
		won=true;
		teamName = input.nextLine();
		country = input.nextLine();
		players = new Player[input.nextInt()];
		for(int i=0; i<players.length; i++) {
			//fills the information of each player.
			players[i] = new Player(input.nextInt(), input.next(), input.next(), input.nextDouble());
		}
		
		formation = input.nextLine();
	}
	
	public String getCountry() {
		//get the country of the team.
		return country;
	}
	
	public String getTeamName() {
		//get the name of the team.
		return teamName;
	}
	
	public int getScoringAbility() {
		//returns the scoring ability of the team based on the sum of all goals each player can achieve.
		int toReturn=0;
		for(int i=0; i<players.length; i++) {
			toReturn+=players[i].getScoredGoals();
		}
		return toReturn;
	}
	
	public boolean getWon() {
		//returns true if the team won, false otherwise.
		return won;
	}
	
	public void setWon(boolean won) {
		//sets the value of won in the team.
		this.won = won;
	}
	
	public void createFirstEleven() {
		//based on the formation of the team, creates a first eleven subteam that consists of defenders, midfielders and forwarders.
		Scanner use = new Scanner(formation);
		int def = use.nextInt();
		int mid = use.nextInt();
		int forw = use.nextInt();
		int compare=0;
		for(int i=0; i<players.length; i++) {
			if(compare>def){
				break;
			}
			if(players[i].getPosition()=="DF"){
				compare++;
				players[i].setIsPlaying(true);
				players[i].calcScoredGoals();
				players[i].getScoredGoals();
			}
		}
		
		compare=0;
		for(int i=0; i<players.length; i++) {
			if(compare>mid){
				break;
			}
			if(players[i].getPosition()=="MF"){
				compare++;
				players[i].setIsPlaying(true);
				players[i].calcScoredGoals();
				players[i].getScoredGoals();
			}
		}
		compare=0;
		
		for(int i=0; i<players.length; i++) {
			if(compare>forw){
				break;
			}
			if(players[i].getPosition()=="FW"){
				compare++;
				players[i].setIsPlaying(true);
				players[i].calcScoredGoals();
				players[i].getScoredGoals();
			}
		}
		
	}
	
	public void scoringAbility() {
		//updates the scoring ability of the team based on the number of goals playing players have scored.
		for(int i=0; i<players.length; i++) {
			if(players[i].getIsPlaying()){
				scoringAbility+=players[i].getScoredGoals();
			}
		}
	}
	
	public Player getBestPlayer() {
		int max = Integer.MIN_VALUE;
		int index=0;
		for(int i=0; i<players.length; i++){
			if(players[i].getIsPlaying()&&players[i].getScoredGoals()>max) {
				max = players[i].getScoredGoals();
				index = i;
				}
		}
		return players[index];
		
	}
	
	public String toString() {
		// returns a String representation of the team.
		String toReturn = teamName + ", " + country + ", " + scoringAbility + "\n";
		for(int i=1; i<=players.length; i++){
			if(players[i-1].getIsPlaying()) {
				toReturn += players[i-1].toString() + "\n";
			}
		}
		return toReturn;
	}
}
